#include "path.h"

const char *path_extension(const char *path)
{
	const char *end, *ext;

  // Go to end of string
	end = ext = path + strlen(path);

  // rfind '.'
	for(; *ext != '.' && ext != path; ext--);

	if(*ext != '.') {
		return end;
	}
  ext++;

  return ext;
}

const char *path_basename(const char *path)
{
	const char *end, *base;

  // Go to end of string
	end = base = path + strlen(path);

  // rfind '/'
	for(; *base != '/' && base != path; base--);

  if(*base == '/') {
    base++;
  }

  return base;
}
