#ifdef BLAS_CHAR
#undef BLAS_CHAR
#endif

#ifdef ELT
#undef ELT
#endif

#ifdef ELT_TYPE
#undef ELT_TYPE
#endif

#ifdef SUFFIXED
#undef SUFFIXED
#undef SUFFIXED2
#undef SUFFIXED3
#endif

#ifndef DOUBLE
  #ifndef COMPLEX
    #define BLAS_CHAR S
    #define ELT float
    #define ELT_TYPE LINALG_SINGLE
  #else
    #error In progress
    #define BLAS_CHAR C
    #define ELT 
    #define ELT_TYPE LINALG_DOUBLE
  #endif
#else
  #ifndef COMPLEX
    #define BLAS_CHAR D
    #define ELT double
    #define ELT_TYPE LINALG_COMPLEX
  #else
    #error In progress
    #define BLAS_CHAR Z
    #define ELT 
    #define ELT_TYPE LINALG_DOUBLE_COMPLEX
  #endif
#endif

#define SUFFIXED3(name, BLAS_CHAR) name ## BLAS_CHAR
#define SUFFIXED2(name, BLAS_CHAR) SUFFIXED3(name, BLAS_CHAR) 
#define SUFFIXED(name) SUFFIXED2(name, BLAS_CHAR) 
