#ifndef __BOXOPT_RUNPARAMS_H__
#define __BOXOPT_RUNPARAMS_H__

#include <cuda_runtime.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
	int threads;
	int blocks;
	int stride;
} runparams_t;

runparams_t runparams(int n, const struct cudaDeviceProp *devprops);

#ifdef __cplusplus
}
#endif

#endif // #ifndef __BOXOPT_RUNPARAMS_H__
