#include "shuffle.h"

void shuffle(int n, int *x, unsigned *seed)
{
  int swap, i;

	if(n <= 1) {
		return;
	}

  // Swap x[0] with a random element
  if(seed == NULL) {
    i = rand();
  }
  else {
    i = rand_r(seed);
    *seed = i;
  }

  i = i % n;

  swap = x[0];
  x[0] = x[i];
  x[i] = swap;

  // Shuffle the remainder of the array
  shuffle(n - 1, x + 1, seed);
}
