from SCons.Script import *
import os, os.path


def loadPackage(env, name, path, url):
    if name not in env['LOADED_PACKAGES']:
        #files = env.SVN(path, url)

        #sconscript_node = None
        #for f in files:
        #    if f.path == os.path.join(path, 'SConscript'):
        #        sconscript_node = f

        # TODO: get SConscript to recognize that the file needs to be built...
        #if sconscript_node:
        #    env.SConscript(sconscript_node)

        env.SVN(path, url)
        SConscript(os.path.join(path, 'SConscript'), exports = {'env': env})
        env['LOADED_PACKAGES'].add(name)

def generate(env):
    if 'LOADED_PACKAGES' not in env:
        env['LOADED_PACKAGES'] = set()
    env.AddMethod(loadPackage, 'Package')

def exists(env):
    return True
