#ifdef BLAS_CHAR
#undef BLAS_CHAR
#endif

#ifdef ELT
#undef ELT
#endif

#ifdef ELT_TYPE
#undef ELT_TYPE
#endif

#ifdef CUSPARSE_FUNCTION
#undef CUSPARSE_FUNCTION
#undef CUSPARSE_FUNCTION2
#undef CUSPARSE_FUNCTION3
#endif

#ifdef SUFFIXED
#undef SUFFIXED
#undef SUFFIXED2
#undef SUFFIXED3
#endif

#ifndef DOUBLE
  #ifndef COMPLEX
    #define BLAS_CHAR S
    #define ELT float
    #define ELT_TYPE LINALG_SINGLE
  #else
    #define BLAS_CHAR C
    #define ELT cuComplex
    #define ELT_TYPE LINALG_DOUBLE
  #endif
#else
  #ifndef COMPLEX
    #define BLAS_CHAR D
    #define ELT double
    #define ELT_TYPE LINALG_COMPLEX
  #else
    #define BLAS_CHAR Z
    #define ELT cuDoubleComplex
    #define ELT_TYPE LINALG_DOUBLE_COMPLEX
  #endif
#endif

#define CUSPARSE_FUNCTION3(func, BLAS_CHAR) cusparse ## BLAS_CHAR ## func
#define CUSPARSE_FUNCTION2(func, BLAS_CHAR) CUSPARSE_FUNCTION3(func, BLAS_CHAR)
#define CUSPARSE_FUNCTION(func) CUSPARSE_FUNCTION2(func, BLAS_CHAR)

#define SUFFIXED3(name, BLAS_CHAR) name ## BLAS_CHAR
#define SUFFIXED2(name, BLAS_CHAR) SUFFIXED3(name, BLAS_CHAR) 
#define SUFFIXED(name) SUFFIXED2(name, BLAS_CHAR) 
