#ifndef __LINALG_MATRIX_DESCRIPTION_INTERNAL_H__
#define __LINALG_MATRIX_DESCRIPTION_INTERNAL_H__

#include <stdint.h>

#include "matrix_description.h"

#define BIT_SYMMETRIC (0x1)

#define BIT_FIELD_DEFAULT 0

struct matdesc
{
  linalg_computation_unit_t computation_unit;
  matrix_storage_scheme_t storage;
  linalg_elt_type_t elt_type;

  uint64_t bit_field;
};

void matdesc_init(matdesc_t *D);
void matdesc_deinit(matdesc_t *D);

#endif // #ifndef __LINALG_MATRIX_DESCRIPTION_INTERNAL_H__
